stages:
  - validate
  - test
  - deploy

checkstyle:
  tags:
    - docker
  image: python:3.8
  stage: validate
  before_script:
    - pip install -r requirements-dev.txt
  script:
    - pycodestyle --show-source --show-pep8 --exclude="docs,.eggs,versioneer.py,*_version.py,venv"

check_dependency_licenses:
  tags:
    - docker
  image: python:3.8
  stage: validate
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
  script:
    - liccheck -s liccheck.ini -r requirements.txt -l STANDARD -R temp.csv --no-deps
    - |
      awk '{
        if ($NF == "OK") {
          license = $(NF - 2)
          for (i = 3; i < NF - 2; i++) {
            license = license " " $(i)
          }
          license = license " " $(NF - 1) " " $NF
        } else {
            license = $(NF - 1) " " $NF
        }
        printf("Package: %s\nVersion: %s\nLicense: %s\n\n", $1, $2, license)
      }' temp.csv > dependencies.csv

    - rm temp.csv

  artifacts:
    paths:
      - dependencies.csv

unit_tests_3.8:
  tags:
    - docker
  image: python:3.8
  stage: test
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - coverage run
    - coverage xml -o coverage.xml
    - coverage report
    - coverage-badge
  coverage: '/TOTAL.+ ([0-9]{1,3}%)/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml

unit_tests_3.11:
  tags:
    - docker
  image: python:3.11
  stage: test
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - python -m unittest -v

unit_tests_3_windows:
  tags:
    - windows
  image: winamd64/python:3.11
  stage: test
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - python -m unittest -v
  allow_failure: true

release:
  tags:
    - docker
  image: python:3.8
  stage: deploy
  before_script:
    - pip install -r requirements.txt -r requirements-dev.txt
    - python -m build
  script:
    - pip install dist/drb-driver-litto3d-$CI_COMMIT_TAG.tar.gz
    - python -m twine upload dist/*
  only:
    - tags

pages:
  stage: deploy
  image: python:3.8
  before_script:
    - pip install -r requirements.txt -r requirements-doc.txt
  script:
    - sphinx-build -b html docs public
  artifacts:
    paths:
      - public
  rules:
    - if: $DOCUMENTATION == "true" && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: always
    - if: $CI_COMMIT_TAG
      when: always
    - when: never
